#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_DiceFishCFG.h"
std::auto_ptr<Fish_DiceFishCFG> Fish_DiceFishCFG::msSingleton(nullptr);

int Fish_DiceFishCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_DiceFishCFGData* Fish_DiceFishCFG::GetData(int Rotation)
{
	auto it = mMapData.find(Rotation);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_DiceFishCFGData>& Fish_DiceFishCFG::GetMapData()
{
	return mMapData;
}

void Fish_DiceFishCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_DiceFishCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_DiceFishCFGData data;
		data.mRotation = element->IntAttribute("Rotation");
		data.mMagnification = element->IntAttribute("Magnification");
		data.mProbability = element->IntAttribute("Probability");
		if (mMapData.find(data.mRotation) != mMapData.end())std::cout <<"data refind:" << data.mRotation << std::endl;
		CCASSERT(mMapData.find(data.mRotation) == mMapData.end(), "data.mRotation is exists");
		mMapData.insert(std::make_pair(data.mRotation, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_DiceFishCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_DiceFishCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_DiceFishCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_DiceFishCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_DiceFishCFGData data;
		LuaCfgHelper::readInt(L, "Rotation", data.mRotation);
		LuaCfgHelper::readInt(L, "Magnification", data.mMagnification);
		LuaCfgHelper::readInt(L, "Probability", data.mProbability);
		if (mMapData.find(data.mRotation) != mMapData.end())std::cout <<"data refind:" << data.mRotation << std::endl;
		CCASSERT(mMapData.find(data.mRotation) == mMapData.end(), "data.mRotation is exists");
		mMapData.insert(std::make_pair(data.mRotation, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_DiceFishCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_DiceFishCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_DiceFishCFG* Fish_DiceFishCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_DiceFishCFG());
	}
	return msSingleton.get();
}

void Fish_DiceFishCFG::Release()
{
	msSingleton.reset(nullptr);
}
